library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library work;
use work.image_pack.all;


entity comp9 is
port(
		a00 : IN pixel;
		a01 : IN pixel;
		a02 : IN pixel;
		a10 : IN pixel;
		a11 : IN pixel;
		a12 : IN pixel;
		a20 : IN pixel;
		a21 : IN pixel;
		a22 : IN pixel;  
	
	choice : in std_logic_vector(1 downto 0); -- 00 : min , 01 : mean , 10 : max , 11 : max
	
	res : out pixel
);
end comp9;

architecture arch1 of comp9 is
component comp3
port(
	a : in pixel;
	b : in pixel;
	c : in pixel;
	
	small : out pixel;
	mid : out pixel;
	big : out pixel
);
end component;

signal s1 : pixel;
signal s2 : pixel;
signal s3 : pixel;
signal s4 : pixel;
signal s5 : pixel;
signal s6 : pixel;
signal s7 : pixel;
signal s8 : pixel;
signal s9 : pixel;

signal o1 : pixel;
signal o2 : pixel;
signal o3 : pixel;
signal o4 : pixel;
signal o5 : pixel;
signal o6 : pixel;
signal o7 : pixel;
signal o8 : pixel;
signal o9 : pixel;

begin
	inst1 : comp3 port map (a00, a01, a02, s1, s2, s3);
	inst2 : comp3 port map (a10, a11, a12, s4, s5, s6);
	inst3 : comp3 port map (a20, a21, a22, s7, s8, s9);
	inst4 : comp3 port map (s1, s4, s7, o1, o2, o3);
	inst5 : comp3 port map (s2, s5, s8, o4, o5, o6);
	inst6 : comp3 port map (s3, s6, s9, o7, o8, o9);

	process(o1,o2,o3,o4,o5,o6,o7,o8,o9, choice)
	begin
		if choice = "00" then 
			res <= o1;
		elsif choice = "01" then
			res <= o5;
		else
			res <= o9;
		end if;
	end process;
end arch1;
