library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library work;
use work.image_pack.all;

entity grad3x3 is
port(
	a00 : in pixel;
	a01 : in pixel;
	a02 : in pixel;
	a10 : in pixel;
	a11 : in pixel;
	a12 : in pixel;
	a20 : in pixel;
	a21 : in pixel;
	a22 : in pixel;
	
	res : out pixel
);
end grad3x3;

architecture arch1 of grad3x3 is

signal s01: std_logic_vector(8 downto 0);
signal s10: std_logic_vector(8 downto 0);
signal s12: std_logic_vector(8 downto 0);
signal s21: std_logic_vector(8 downto 0);


signal s1: std_logic_vector(8 downto 0);
signal s2: std_logic_vector(8 downto 0);
signal s3: std_logic_vector(9 downto 0);
signal s4: std_logic_vector(9 downto 0);
signal s5: std_logic_vector(10 downto 0);

signal s6: std_logic_vector(8 downto 0);
signal s7: std_logic_vector(8 downto 0);
signal s8: std_logic_vector(9 downto 0);
signal s9: std_logic_vector(9 downto 0);
signal s_10: std_logic_vector(10 downto 0);

signal gx: std_logic_vector(10 downto 0);
signal gy: std_logic_vector(10 downto 0);
signal gxy: std_logic_vector(10 downto 0);

begin 
	s01 <= a01 & '0';
	s10 <= a10 & '0';
	s12 <= a12 & '0';
	s21 <= a21 & '0';
	
	s1 <= ('0' & a02) + ('0' & a22);
	s2 <= ('0' & a00) + ('0' & a20);
	s3 <= ('0' & s1 ) + ('0' & s12);
	s4 <= ('0' & s2 ) + ('0' & s10);
	s5 <= ('0' & s3 ) - ('0' & s4 );
	
	s6 <= ('0' & a00) + ('0' & a02);
	s7 <= ('0' & a20) + ('0' & a22);
	s8 <= ('0' & s6 ) + ('0' & s01);
	s9 <= ('0' & s7 ) + ('0' & s21);
	s_10 <= ('0' & s8) - ('0' & s9);
	
	gx <= abs(signed(s5));
	gy <= abs(signed(s_10));
	
	gxy <= gx + gy;
	
	res <= gxy(10 downto 3);

end arch1;
