library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library work;
use work.image_pack.all;

entity gradPM is
port(
	a00 : in pixel;
	a01 : in pixel;
	a02 : in pixel;
	a10 : in pixel;
	a11 : in pixel;
	a12 : in pixel;
	a20 : in pixel;
	a21 : in pixel;
	a22 : in pixel;
	
	res : out pixel
);
end gradPM;

architecture arch1 of gradPM is

signal s01: std_logic_vector(8 downto 0);
signal s10: std_logic_vector(8 downto 0);
signal s12: std_logic_vector(8 downto 0);
signal s21: std_logic_vector(8 downto 0);


signal s1: std_logic_vector(8 downto 0);
signal s2: std_logic_vector(8 downto 0);
signal s3: std_logic_vector(9 downto 0);
signal s4: std_logic_vector(9 downto 0);
signal s5: std_logic_vector(10 downto 0);

signal s6: std_logic_vector(8 downto 0);
signal s7: std_logic_vector(8 downto 0);
signal s8: std_logic_vector(9 downto 0);
signal s9: std_logic_vector(9 downto 0);
signal s_10: std_logic_vector(10 downto 0);

signal gx: std_logic_vector(10 downto 0);
signal gy: std_logic_vector(10 downto 0);
signal gxy: std_logic_vector(10 downto 0);

signal gxM: std_logic_vector(12 downto 0);
signal gyM: std_logic_vector(12 downto 0);

signal sign : std_logic_vector(1 downto 0);

signal xbig : std_logic;
signal ybig : std_logic;

signal big : std_logic_vector(1 downto 0);

signal choice : std_logic_vector(1 downto 0);

signal dir : std_logic_vector(1 downto 0);

begin 
	s01 <= a01 & '0';
	s10 <= a10 & '0';
	s12 <= a12 & '0';
	s21 <= a21 & '0';
	
	s1 <= ('0' & a02) + ('0' & a22);
	s2 <= ('0' & a00) + ('0' & a20);
	s3 <= ('0' & s1 ) + ('0' & s12);
	s4 <= ('0' & s2 ) + ('0' & s10);
	s5 <= ('0' & s3 ) - ('0' & s4 );
	
	s6 <= ('0' & a00) + ('0' & a02);
	s7 <= ('0' & a20) + ('0' & a22);
	s8 <= ('0' & s6 ) + ('0' & s01);
	s9 <= ('0' & s7 ) + ('0' & s21);
	s_10 <= ('0' & s8) - ('0' & s9);
	
	gx <= abs(signed(s5));
	gy <= abs(signed(s_10));
	
	gxy <= gx + gy;
	
	--res <= gxy(10 downto 3);
	
	sign<=s5(10) & s_10(10);
		
	gxM <= ('0' & gx & '0') + ("00" & gx(10 downto 1)); -- gxM = 2.5*gx = 2*gx + 0.5*gx
	gyM <= ('0' & gy & '0') + ("00" & gy(10 downto 1));


	xbig<='1' when gxM > gy else '0';
	ybig<='1' when gyM > gx else '0';

	big<= xbig & ybig;
	
	choice <= "10" when (sign="00" or sign="11") else "11";
	
	dir <= choice when big="00" else "00" when big="10" else "01" when big="01";

-- convention :
-- | : 00
-- __ : 01
-- / : 10
-- \ : 11

	res <= dir & gxy(10 downto 5);

end arch1;

