library IEEE;
use IEEE.STD_LOGIC_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package image_pack is
constant width  : integer := 356;  --252; --356;--32; --16; --356;--128;--16;--1024;
constant width4 : integer := width/4;
constant height : integer := 147; --252; --292;--32;--292;--4;--1024;

constant my_stack_size : integer := width4 * height;

constant nb_ops : integer := 4;
constant pixel_size : integer := 8;
constant input_size : integer := pixel_size*(width)-1;
constant slice_size : integer := (pixel_size*(width+2))-1;
constant out_slice_size : integer := ((nb_ops+2)*pixel_size)-1;
constant window_size : integer := (9*pixel_size)-1;

constant oper_size : integer := 127;
constant oper_size32 : integer := oper_size/32;

subtype pixel is std_logic_vector(7 downto 0);
subtype slice is std_logic_vector(slice_size downto 0);
subtype out_slice is std_logic_vector(out_slice_size downto 0);

constant input_slice_size : integer := pixel_size*(width)-1;
subtype input_slice is std_logic_vector(input_slice_size downto 0);

end image_pack;

