library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
library work;
use work.image_pack.all;

entity operators is
port(
	in1 : in std_logic_vector(47 downto 0);-- 6 up pixels
	in2 : in std_logic_vector(47 downto 0);-- 6 mid pixels
	in3 : in std_logic_vector(47 downto 0);-- 6 down pixels
	oper : in std_logic_vector(oper_size downto 0);
	
	outpixels : out std_logic_vector(31 downto 0)
);
end operators;

architecture arch1 of operators is
component operator is
port(
	in1 : in std_logic_vector(23 downto 0);-- 3 up pixels
	in2 : in std_logic_vector(23 downto 0);-- 3 mid pixels
	in3 : in std_logic_vector(23 downto 0);-- 3 down pixels
	oper : in std_logic_vector(oper_size downto 0);
	
	outpixel : out  pixel
);
end component;

begin
	inst1 : operator port map (in1(47 downto 24), in2(47 downto 24), in3(47 downto 24), oper,  outpixels(31 downto 24));
	inst2 : operator port map (in1(39 downto 16), in2(39 downto 16), in3(39 downto 16), oper,  outpixels(23 downto 16));
	inst3 : operator port map (in1(31 downto 8),  in2(31 downto 8),  in3(31 downto 8),  oper,  outpixels(15 downto 8));
	inst4 : operator port map (in1(23 downto 0),  in2(23 downto 0),  in3(23 downto 0),  oper,  outpixels(7 downto 0));

end arch1;

